#ifndef FUNCONANDOFFJOB_H
#define FUNCONANDOFFJOB_H

#include "FuncBase.h"

/**
 * @brief 在岗离岗检测
 * 
 */


 /**
  * @brief 检测信息
  * 
  */
struct DecCondition
{
    int ChannelID;                  /* 通道ID */
    int leaveNum;                   /* 离岗次数 */
    int leaveNumOnTime;             /* 一定时间内的离岗次数 */
    int leaveOneTime;               /* 单次离开报警时间 */

    DecCondition();
    DecCondition(const DecCondition& other);
    DecCondition& operator=(const DecCondition& other);
};

/**
 * @brief 房间在岗信息
 * 
 */
 struct RoomOnWorkInfo
 {
    bool bOnWork = false;          /* 是否在岗 */
    int RoomID;                     /* 房间ID */
    int CameraID;                   /* 摄像机ID */
    int RoomType;                   /* 房间类型 */
    QDateTime StartTime;            /* 开始时间 */
    QDateTime EndTime;              /* 结束时间 */
    std::string strImagePath;       /* 图片路径 */
    std::list<PersonInfo> listPersonInfo; /* 人员信息 */

    RoomOnWorkInfo() = default;
    RoomOnWorkInfo& operator=(const RoomOnWorkInfo& other);
    RoomOnWorkInfo(const RoomOnWorkInfo& other);
};




class FuncOnAndOffJob : public FuncBase
{
public:
    FuncOnAndOffJob();
    ~FuncOnAndOffJob();

private:
    /* 获取当前频率信息 */
    bool getCurrentFrequencyInfo(const int ChannelID, DecCondition& info);
    
protected:
    void task() override;

private:
    ListAlarmInfo* m_pListAlarm = nullptr;                  /* 报警信息 */
    // std::map<int, ListAlarmInfo*> m_mapRoomPersonCount;     /* 人员计数返回的信息，int是房间ID号 */
    // std::map<int, ListAlarmInfo*> m_mapRoomFaceInfo;        /* 人脸识别返回的信息，int是房间ID号 */
    std::map<int, RoomOnWorkInfo*> m_mapRoomOnWorkInfo;      /* 房间在岗信息 */
};



#endif /* FUNCONANDOFFJOB_H */
